<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for FileTypeComparator.
 * Generated by PHPUnit on 2012-07-03 at 17:39:23.
 * @group directory_iterators
 */
class FileTypeComparatorTest extends \PHPUnit_Framework_TestCase {

    /** @var FileTypeComparator */
    private $comparator;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $fileElement;
    /** @var Treewec\DirectoryIterators\IteratorElement */
    private $dirElement;

    protected function setUp() {
        $this->comparator = new FileTypeComparator();
        $this->fileElement = new IteratorElement(0, new \SplFileInfo(TREEWEC_VIEW_DIR . 'navigation.php'));
        $this->dirElement = new IteratorElement(0, new \SplFileInfo(TREEWEC_VIEW_DIR));
    }

    public function testCompare() {
        $this->assertFileFilter();
        $this->assertDirFilter();
    }

    private function assertFileFilter() {
        $this->comparator->setFileTypeFilter(\Treewec\FileSystem\FileType::FILE);
        parent::assertEquals($this->comparator->compare($this->fileElement, $this->fileElement), 0);
        parent::assertEquals($this->comparator->compare($this->fileElement, $this->dirElement), 1);
        parent::assertEquals($this->comparator->compare($this->dirElement, $this->fileElement), -1);
    }

    private function assertDirFilter() {
        $this->comparator->setFileTypeFilter(\Treewec\FileSystem\FileType::FOLDER);
        parent::assertEquals($this->comparator->compare($this->dirElement, $this->dirElement), 0);
        parent::assertEquals($this->comparator->compare($this->dirElement, $this->fileElement), 1);
        parent::assertEquals($this->comparator->compare($this->fileElement, $this->dirElement), -1);        
    }

}

?>